#include "stdafx.h"
#include "Camera.h"

namespace SceneManagement
{
	Camera::Camera() 
	{
		fi = 0;
		psi = 45;
//		radius = 5;
		radius = 50;
		sensitivity = 0.5f;
		position = Vector3f(0,0,0);
		state = 0;
	}

	void Camera::CameraUpdate(Vector2f mouseDelta)
	{
		Matrix4f matrix;

		if ( testBit(CAMERA_ZOOMING, state) ) 
		{
			radius += radius*mouseDelta.y * 0.01f * sensitivity;
			if ( radius < 1 ) radius = 1;
		}

		if ( testBit(CAMERA_ROTATING, state) ) 
		{
			fi += mouseDelta.x * sensitivity;
			psi += mouseDelta.y * sensitivity;

			if ( psi > 90 ) psi = 90;
			else if ( psi < 10) psi = 10;
		}

		if ( testBit(CAMERA_MOVING, state ) ) 
		{
			GLfloat cameraDX = radius * mouseDelta.x * 0.002f * sensitivity;
			GLfloat cameraDY = radius * -mouseDelta.y * 0.002f * sensitivity;

			glPushMatrix();

			glLoadIdentity();
			glRotatef(-fi, 0, 0, 1);
			glTranslatef(cameraDX, cameraDY, 0);
			glRotatef(fi, 0, 0, 1);

			glGetFloatv(GL_MODELVIEW_MATRIX, matrix);

			position.x += matrix[12];
			position.y += matrix[13];

			glPopMatrix();
		}
	}

	void Camera::CameraZoomAndRotate() 
	{
		glTranslatef(0, 0, -radius);
		glRotatef(psi - 90, 1, 0, 0);
		glRotatef(fi, 0, 0, 1);
	}

	void Camera::CameraPan() 
	{
		glTranslatef(position.x, position.y, position.z);
	}
}
