#include "stdafx.h"
#include "Cell.h"
#include "glut.h"
#include "glu.h"

namespace SceneManagement
{
	void Cell::UpdatePos(GLfloat x, GLfloat y, GLfloat z)
	{
		double winX, winY, winZ;
        
		double modelMatrix[16];
        double projectionMatrix[16];
        int viewport[4];

        glGetDoublev (GL_MODELVIEW_MATRIX, modelMatrix);
        glGetDoublev(GL_PROJECTION_MATRIX, projectionMatrix);
        glGetIntegerv(GL_VIEWPORT, viewport);

        double tmpX, tmpY, tmpZ;

        if (gluProject(x, y, z, modelMatrix, projectionMatrix, viewport, &winX, &winY, &winZ) == GL_FALSE)
		{
			x = 0;
			y = 0;
			return;
		}

		this->x = (int) winX;
        this->y = (int) winY;
	}

	void Cell::DrawString2D(GLuint x, GLuint y, char* format, ...)
	{
		va_list args;
		char buffer[255], *s;
	    
		va_start(args, format);
		vsprintf(buffer, format, args);
		va_end(args);
	    
		glRasterPos2i(x, y);
		for (s = buffer; *s; s++)
			glutBitmapCharacter(font_style, *s);
	}

	void Cell::DrawString3D(GLfloat _x, GLfloat _y, GLfloat _z, char* format, ...)
	{
		//UpdatePos(_x, _y, _z);
		va_list args;
		char buffer[255], *s;
	    
		va_start(args, format);
		vsprintf(buffer, format, args);
		va_end(args);
	    
//		glRasterPos3i(_x, _y, _z);
		glRasterPos3f(_x, _y, _z);
		for (s = buffer; *s; s++)
			glutBitmapCharacter(font_style, *s);
	}

	void Cell::SetFont(char* name, int size)
	{
		font_style = GLUT_BITMAP_HELVETICA_10;
		if (strcmp(name, "helvetica") == 0) 
		{
			if (size == 12) 
				font_style = GLUT_BITMAP_HELVETICA_12;
			else if (size == 18)
				font_style = GLUT_BITMAP_HELVETICA_18;
		} 
		else if (strcmp(name, "times roman") == 0) 
		{
			font_style = GLUT_BITMAP_TIMES_ROMAN_10;
			if (size == 24)
				font_style = GLUT_BITMAP_TIMES_ROMAN_24;
		} 
		else if (strcmp(name, "8x13") == 0) 
		{
			font_style = GLUT_BITMAP_8_BY_13;
		} 
		else if (strcmp(name, "9x15") == 0) 
		{
			font_style = GLUT_BITMAP_9_BY_15;
		}
	}


}
