#pragma once
#include <glut.h>
#include "Entity.h"
//#include <glaux.h>		// Header File For The Glaux Library

namespace SceneManagement
{
	class Cell : public Entity
	{
	public:
		int ID;
		int x, y;
		float minValue, maxValue;
		float value;
		float step;
		char* info;
		char* format;
		GLvoid *font_style;

		Cell(void);
		Cell(int _ID, int _x, int _y, float _minValue, float _maxValue, float _value, float _step, char* _info, char* _format); 
		~Cell(void);
		
		void SetFont(char* name, int size);
		void DrawInfo(){DrawString2D(x, y, info);}
		void DrawValue(){DrawString2D(x + 75, y, format, value);}

		bool Cell_Hit(Cell* cell, int x, int y){return x > this->x && x < this->x+50 && y > this->y-20 && y < this->y+10; }

		void DrawString2D(GLuint x, GLuint y, char* format, ...);
		void DrawString3D(GLfloat x, GLfloat y, GLfloat z, char* format, ...);

	private:
		void UpdatePos(GLfloat x, GLfloat y, GLfloat z);
	};


	inline Cell::Cell(void) : ID(0), x(0), y(0), minValue(0.0f), maxValue(1.0f), step(0.0f), info(""), format("%.3f")
	{
		font_style = GLUT_BITMAP_HELVETICA_12;
	}

	inline Cell::Cell(int _ID, int _x, int _y, float _minValue, float _maxValue, float _value, float _step, char* _info, char* _format) 
			: ID(_ID), x(_x), y(_y), minValue(_minValue), maxValue(_maxValue), value(_value), step(_step), info(_info), format(_format)
	{
		font_style = GLUT_BITMAP_HELVETICA_12;
	}

	inline Cell::~Cell(void)
	{
	}
}