#include "stdafx.h"
#include "Mouse.h"

namespace SceneManagement
{
	Mouse* Mouse::CALLBACK_INSTANCE = NULL;

	void Mouse::ActiveMouseMove(int x, int y) 
	{
		delta.x = x - lastPosition.x;
		delta.y = y - lastPosition.y;

		lastPosition.x = x;
		lastPosition.y = y;

		camera->CameraUpdate(delta);
		SceneManager::GetInstance()->Redisplay();
	}

	void Mouse::ActiveMouseMoveCB(int x, int y) 
	{
		CALLBACK_INSTANCE->ActiveMouseMove(x,y);
	}

	void Mouse::PassiveMouseMove(int x, int y) 
	{
		//SceneManager::GetInstance()->Pick(x,y);
		//SceneManager::GetInstance()->Redisplay();
	}

	void Mouse::PassiveMouseMoveCB(int x, int y) 
	{
		CALLBACK_INSTANCE->PassiveMouseMove(x,y);
	}

	void Mouse::MouseClick(int button, int buttonState, int x, int y) 
	{
		int mode = 0;
		specialKey = glutGetModifiers();
		switch ( button ) 
		{
			case GLUT_LEFT_BUTTON: //LEFT
				switch (specialKey)
				{
					case GLUT_ACTIVE_CTRL:
						mode = CAMERA_ROTATING;
						break;
					case GLUT_ACTIVE_ALT:
						mode = CAMERA_ZOOMING;
						break;
					case GLUT_ACTIVE_SHIFT:
						mode = CAMERA_MOVING;
						break;
					default:
						mode = CAMERA_ROTATING;
						break;
				}
				break;
			case GLUT_MIDDLE_BUTTON: //MIDDLE
				mode = CAMERA_ZOOMING;
				break;
			case GLUT_RIGHT_BUTTON: //RIGHT
				mode = CAMERA_MOVING;
				break;
		}
		
		if ( buttonState == GLUT_DOWN ) 
		{
			camera->state = mode;  

			startDrag.x = x;
			startDrag.y = y;

			lastPosition.x = x;
			lastPosition.y = y;
		}
		else 
		{		
			camera->state = 0;
		}
	
	}

	void Mouse::MouseClickCB(int button, int buttonState, int x, int y) 
	{
		CALLBACK_INSTANCE->MouseClick(button, buttonState, x, y);
	}
}