#pragma once
#include "vmath.h"
#include "utils.h"
#include "Camera.h"
#include "SceneManager.h"
#include "glut.h"


namespace SceneManagement
{
	class Mouse {
	private:
		int specialKey;

	public:
		static Mouse* CALLBACK_INSTANCE;
		Vector2f	startDrag;
		Vector2f	lastPosition;
		Vector2f	delta;

		Camera*		camera;

		inline Mouse(void){};
		inline Mouse(Camera* cam) : camera(cam){};
		inline ~Mouse(void){};

		void		ActiveMouseMove(int x, int y);		//When the button is pressed
		static void ActiveMouseMoveCB(int x, int y);

		void		PassiveMouseMove(int x, int y);		//When the button is not pressed
		static void PassiveMouseMoveCB(int x, int y);

		void		MouseClick(int button, int buttonState, int x, int y);
		static void MouseClickCB(int button, int buttonState, int x, int y);
	};
}