#ifndef TIME_UTILS_H
#define TIME_UTILS_H

#ifndef WIN32
#define __int64 long long
#endif

/*******************************************************************************************/
/*Timer                                                                                    */
/*                                                                                         */
/*******************************************************************************************/

class Timer
{
  public:
    static void intialize();

  /*
   *Read the system's current time and return it
   **/
    static __int64 getCurrentTime();

   /*
    *Return the timer's precision (frequency)
    **/
    static __int64 getPrecision();

   /*
    *Return the elapsed time in seconds
    **/
    static float getElapsedTimeSeconds(__int64 lastTime);
};

/*******************************************************************************************/
/*FPSCounter                                                                               */
/*                                                                                         */
/*******************************************************************************************/

class FPSCounter
{
  public:
    FPSCounter();

    const float getFrameInterval() const;
    const float getElapsedTime()   const;
    const float getFPS()           const;

    virtual void  markFrameStart();
    virtual void  markFrameEnd();

  protected:
    __int64  frameStart;       // Mark the beginning of a frame
    float    frameInterval,    //The delay between two frames
             elapsedTime,
             internalFPS,      //An internal FPS counter
             tickCounter,      //This will count the clock ticks
             fps;              //The number of frames per second

};

#endif
