#pragma once
#include "Entity.h"
#include "vmath.h"
#include "Cell.h"

#define RING_SLICES 150
#define RING_MIN 1.1
#define RING_MAX 1.6

namespace SceneManagement
{
	class planet : public Entity
	{
	public:
		planet(GLuint, GLfloat, GLfloat[3], GLfloat, char*);
		planet(GLuint*, GLfloat, GLfloat[3], GLfloat, char*);
		~planet(void);
		void Draw();

	private:
		void createRing();
		GLUquadric *qPlanet;
		bool haveRing;
		GLfloat ringVertices[(RING_SLICES + 1) * 4];
		GLfloat ringTexCoords[(RING_SLICES + 1) * 4];
		GLfloat ringNormals[(RING_SLICES + 1) * 6];
		GLuint tex;
		GLuint texRing;
		GLuint texRingTrans;
		Cell* cell;
		GLfloat size, rotation;
		GLfloat position[3];
		char name[255];
	};
}
