#pragma once

#include <glew.h>
#include <assert.h>
#include <string.h>
#include <stdlib.h>

namespace SceneManagement
{
	enum ShaderState
	{
		UNKNOWN = 0, 
		LOADED,
		CREATED,
		COMPILED
	};

	enum ShaderType : int
	{
        VERTEX_SHADER = GL_VERTEX_SHADER_ARB,
        FRAGMENT_SHADER = GL_FRAGMENT_SHADER_ARB
	};

	class Shader
	{
	protected:
		ShaderState shaderState;
		ShaderType shaderType;
		GLuint shaderObject;
	    			
	public:
		Shader(ShaderType type=SceneManagement::VERTEX_SHADER);
		 ~Shader();
	   
		inline GLhandleARB getShader()  { return shaderObject; }
		 
		void create();
		void openFromFile(const char *filename);
		void openFromArray(const char *data);
	    char *getInfoLog();

		friend class ShaderProgram;
	};

}



