#pragma once
#include <glew.h>
#include "shader.h"

namespace SceneManagement
{
	class ShaderProgram
	{
	public:
		GLuint programObject;
		Shader *vertexShader;
		Shader *fragmentShader;
	    
	private:
		bool vertexShaderUsed;
		bool fragmentShaderUsed;
		bool enabled;
		char *getInfoLog();
	    
	public:
		ShaderProgram(Shader *vertexShader, Shader *fragmentShader);
		~ShaderProgram();
	   
		void enableVertexShader();
		void enableFragmentShader();
		void enableShaders();

		void disableVertexShader();
		void disableFragmentShader();
		void disableShaders();

		void enable();
		void disable();
	};
}