#include "stdafx.h"
#include "sun.h"
#include "glut.h"
#include "glu.h"

namespace SceneManagement
{
	sun::sun(GLuint texture, GLfloat psize, GLfloat pposition[3])
	{
		qSun = gluNewQuadric();
		tex = texture;
		cell = new Cell();
		size = psize;
		position[0] = pposition[0];
		position[1] = pposition[1];
		position[2] = pposition[2];
	}

	sun::~sun()
	{
		gluDeleteQuadric(qSun);
		delete cell;
	}

	void sun::Draw()
	{
		glPushAttrib(GL_COLOR_MATERIAL | GL_LIGHTING);
		glDisable(GL_LIGHTING); glEnable(GL_DEPTH_TEST);
	
	// For lighting, pull our material colors from the vertex color...
	        float mAmbientDiffuse[4] = { 0.0, 0.0, 0.0, 1 };
        	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, mAmbientDiffuse);

//    glColorMaterial( GL_FRONT, GL_AMBIENT_AND_DIFFUSE );
		glEnable( GL_COLOR_MATERIAL );


		static float angle = 0.0; angle += 0.025;
		glPushMatrix();

		glTranslatef(position[0], position[1], position[2]);
		glRotatef(angle, 0, 0, 1);  //otaceni planety kolem vlastni osy
		glScalef(size, size, size);  //velikost planety

		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, tex);
		glColor4f(1.0, 1.0, 1.0, 1.0);
		gluQuadricTexture(qSun, true);
		gluSphere(qSun, 1.0, RING_SLICES/2, RING_SLICES/2);
		glDisable(GL_TEXTURE_2D);
		glPopMatrix();

		glDisable(GL_LIGHTING);
		glDisable(GL_DEPTH_TEST);
		glColor4f(1.0, 0.02, 0.05, 1.0);
		cell->DrawString3D(0.0,0.0,size+2.0, "Sun");
		glEnable(GL_DEPTH_TEST);
		glEnable(GL_LIGHTING);

		glPopAttrib();
	}
}
