#include "stdafx.h"
#include "texgen.h"
#include "glut.h"
#include "glu.h"

namespace SceneManagement
{
	texgen::texgen(GLuint texture)
	{
		tex = texture;
		q = gluNewQuadric();
	}

	texgen::~texgen()
	{
		gluDeleteQuadric(q);
	}

	void texgen::Draw()
	{
		glDisable(GL_LIGHTING);
		glEnable(GL_TEXTURE_GEN_S);
		glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
		GLfloat s_plane[] = {0,0,1,0};
		glTexGenfv(GL_S, GL_OBJECT_PLANE, s_plane);
		glEnable(GL_TEXTURE_1D);
		glBindTexture(GL_TEXTURE_1D, tex);

		float scale = 1.0;
		glBegin(GL_QUADS);
			glColor3f(1.0f,1.0f,1.0f);
			glNormal3f( 0.0f, -1.0f, 0.0f);
			glVertex3f(-scale, -scale, -scale); 
			glVertex3f( scale, -scale, -scale);
			glVertex3f( scale, -scale,  scale);
			glVertex3f(-scale, -scale,  scale);

			glColor3f(1.0f,1.0f,1.0f);
			glNormal3f( 0.0f, 1.0f, 0.0f); 
			glVertex3f(-scale,  scale, -scale);
			glVertex3f(-scale,  scale,  scale);
			glVertex3f( scale,  scale,  scale);
			glVertex3f( scale,  scale, -scale);

			glColor3f(1.0f,1.0f,1.0f);
			glNormal3f( 0.0f, 0.0f,-1.0f); 
			glVertex3f(-scale, -scale, -scale);
			glVertex3f(-scale,  scale, -scale);
			glVertex3f( scale,  scale, -scale);
			glVertex3f( scale, -scale, -scale);

			glColor3f(1.0f,1.0f,1.0f);
			glNormal3f( 1.0f, 0.0f, 0.0f);
			glVertex3f( scale, -scale, -scale); 
			glVertex3f( scale,  scale, -scale);
			glVertex3f( scale,  scale,  scale);
			glVertex3f( scale, -scale,  scale);

			glColor3f(1.0f,1.0f,1.0f);
			glNormal3f( 0.0f, 0.0f, 1.0f); 
			glVertex3f(-scale, -scale,  scale);
			glVertex3f( scale, -scale,  scale);
			glVertex3f( scale,  scale,  scale); 
			glVertex3f(-scale,  scale,  scale);

			glColor3f(1.0f,1.0f,1.0f);
			glNormal3f(-1.0f, 0.0f, 0.0f);  
			glVertex3f(-scale, -scale, -scale); 
			glVertex3f(-scale, -scale,  scale);
			glVertex3f(-scale,  scale,  scale);
			glVertex3f(-scale,  scale, -scale);

		glEnd();
		glDisable(GL_TEXTURE_GEN_S);
		glDisable(GL_TEXTURE_1D);
	}
}
